#!/bin/bash
#### "***********************************************"
#### "*       ..:: Script by MOHAMED_OS ::..        *"
#### "*  Support: https://github.com/MOHAMED19OS    *"
#### "*       E-Mail: mohamed19eng@gmail.com        *"
#### "***********************************************"

CAMNAME="GosatPlus_Oscam"
CAM_BIN="OSCam_11778-r801"
BINARY="GosatPlus"

remove_tmp() {
  rm -rf /tmp/*.info* /tmp/*.tmp* /tmp/*share* /tmp/*.pid* /tmp/*sbox* /tmp/oscam* /tmp/.oscam
}

case "$1" in
start)
  echo "[SCRIPT] $1: $CAMNAME"
  remove_tmp
  touch /tmp/.emu.info
  echo ${CAMNAME} >/tmp/.emu.info
  /usr/bin/${CAM_BIN} --config-dir /etc/tuxbox/config --daemon --pidfile /tmp/${CAM_BIN}.pid --restart 2 --utf8 2 | grep -v "UTF-8 mode"
  /usr/bin/"${BINARY}" --config-dir /etc/tuxbox/"${BINARY}" --daemon --pidfile /tmp/"${BINARY}".pid --restart 2 --utf8 2 | grep -v "UTF-8 mode"
  ;;
stop)
  echo "[SCRIPT] $1: $CAMNAME"
  killall -9 ${CAM_BIN} 2>/dev/null
  killall -9 ${BINARY} 2>/dev/null
  remove_tmp
  ;;
restart)
  $0 stop
  sleep 2
  $0 start
  exit
  ;;
*)
  $0 stop
  exit 0
  ;;
esac

exit 0
